// RSSMU_AWGN_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSMU_AWGN_Example.h"
#include "RSSMU_AWGN_ExampleDlg.h"
#include "Resource.h"
#include "rssmu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_AWGN_ExampleDlg dialog

CRSSMU_AWGN_ExampleDlg::CRSSMU_AWGN_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSMU_AWGN_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSMU_AWGN_ExampleDlg)
	m_ResName = _T("GPIB::28");
	m_AWGNState = FALSE;
	m_AWGNMode = 0;
	m_DMState = FALSE;
	m_Query = TRUE;
	m_MinimumNoise = 1.0;
	m_Reset = TRUE;
	m_RFFreq = 1.00E+9;
	m_RFLevel = -30.00;
	m_RFState = FALSE;
	m_SystemBandwidth = 384000.00;
	m_CarrierRatio = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSMU_AWGN_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSMU_AWGN_ExampleDlg)
	DDX_Text(pDX, IDC_RESOURCE_DESCRIPTOR, m_ResName);
	DDX_Check(pDX, IDC_AWGN_STATE, m_AWGNState);
	DDX_CBIndex(pDX, IDC_AWGN_MODE, m_AWGNMode);
	DDX_Check(pDX, IDC_DM_STATE, m_DMState);
	DDX_Check(pDX, IDC_ID_QUERY, m_Query);
	DDX_Text(pDX, IDC_MINNOISE, m_MinimumNoise);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RF_FREQ, m_RFFreq);
	DDX_Text(pDX, IDC_RF_LEVEL, m_RFLevel);
	DDX_Check(pDX, IDC_RF_STATE, m_RFState);
	DDX_Text(pDX, IDC_SYSTEMBW, m_SystemBandwidth);
	DDX_Text(pDX, IDC_CARRIERRATIO, m_CarrierRatio);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSMU_AWGN_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSMU_AWGN_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDAPPLY, OnApply)
	ON_CBN_SELCHANGE(IDC_AWGN_MODE, OnSelchangeAwgnMode)
	ON_EN_KILLFOCUS(IDC_MINNOISE, OnKillfocusMinnoise)
	ON_EN_KILLFOCUS(IDC_CARRIERRATIO, OnKillfocusCarrierratio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSMU_AWGN_ExampleDlg message handlers

BOOL CRSSMU_AWGN_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CWnd*	pdlg_item;
	bool	state;

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	state = (m_AWGNMode == 0); 
	pdlg_item = GetDlgItem(IDC_CARRIERRATIO);
	pdlg_item->EnableWindow(state);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSMU_AWGN_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSMU_AWGN_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSMU_AWGN_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSMU_AWGN_ExampleDlg::OnApply() 
{
	ViStatus	rssmu_status;
	ViSession	instrSession;
	char		buffer[512];
	CString		str;
	
	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
	SetCursor ( cur );
	
	UpdateData();

    /* Initialize the driver */
	rssmu_status = rssmu_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &instrSession);
	if (rssmu_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}

	FT_CHECKERR (rssmu_SetDMAcctoStandard (instrSession, RSSMU_PATH_A, RSSMU_DM_DIGITAL_STANDARD_W3GPP), 
															"rssmu_SetDMAcctoStandard");
	
	FT_CHECKERR (rssmu_SetDMState (instrSession, RSSMU_PATH_A, m_DMState), "rssmu_SetDMState");

	FT_CHECKERR (rssmu_SetAWGNSystemBandwidth (instrSession, RSSMU_PATH_A, m_SystemBandwidth), 
														"rssmu_SetAWGNSystemBandwidth");
	FT_CHECKERR (rssmu_SetAWGNMode (instrSession, RSSMU_PATH_A, m_AWGNMode), "rssmu_SetAWGNMode");
	FT_CHECKERR (rssmu_SetAWGNSystemBandwidthRatio (instrSession, RSSMU_PATH_A, m_MinimumNoise), 
															"rssmu_SetAWGNSystemBandwidthRatio");
	if (!m_AWGNMode)
	{
		FT_CHECKERR (rssmu_SetAWGNCarriertoNoiseRatio (instrSession, RSSMU_PATH_A, m_CarrierRatio), 
																"rssmu_SetAWGNCarriertoNoiseRatio");
	}
	FT_CHECKERR (rssmu_SetAWGNState (instrSession, RSSMU_PATH_A, m_AWGNState), "rssmu_SetAWGNState");

	FT_CHECKERR (rssmu_SetRFAmplitude (instrSession, RSSMU_PATH_A, m_RFLevel), "rssmu_SetRFAmplitude");
	FT_CHECKERR (rssmu_SetRFFrequency (instrSession, RSSMU_PATH_A, m_RFFreq), "rssmu_SetRFFrequency");
	FT_CHECKERR (rssmu_SetOutputState (instrSession, RSSMU_PATH_A, m_RFState), "rssmu_SetOutputState");
	rssmu_close(instrSession);
	
}

void CRSSMU_AWGN_ExampleDlg::OnSelchangeAwgnMode() 
{

	CWnd*	pdlg_item;
	bool	state;
	
	UpdateData(TRUE);
	state = (m_AWGNMode == 0); 
	pdlg_item = GetDlgItem(IDC_CARRIERRATIO);
	pdlg_item->EnableWindow(state);
}

void CRSSMU_AWGN_ExampleDlg::OnKillfocusMinnoise() 
{
	// TODO: Add your control notification handler code here
	double	min;
	double	max;
	CString message;

	min = 1;
	max = 21;
	
	UpdateData(TRUE);
	if ((m_MinimumNoise <min) || (m_MinimumNoise >max))
	{
		message.Format("Please enter value in range %.1lf to %.1lf!",min,max);
		AfxMessageBox (message, MB_OK);
		m_MinimumNoise = min;
		UpdateData(FALSE);
	}	
}

void CRSSMU_AWGN_ExampleDlg::OnKillfocusCarrierratio() 
{
	// TODO: Add your control notification handler code here
	double	min;
	double	max;
	CString message;

	min = -30;
	max = 30;
	
	UpdateData(TRUE);
	if ((m_CarrierRatio <min) || (m_CarrierRatio >max))
	{
		message.Format("Please enter value in range %.1lf to %.1lf!",min,max);
		AfxMessageBox (message, MB_OK);
		m_CarrierRatio = min;
		UpdateData(FALSE);
	}	
}
